﻿#define OEM_TEST_WDT
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GPIOTest
{
    public partial class Form1 : Form
    {
        int retvalue;
        IntPtr m_HModule;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            retvalue = Libioctrl.libIoCtrlInit(ref m_HModule, "C58.C57-H2.XX");

        }

        private void button1_Click(object sender, EventArgs e)
        {
            byte Value1 = 1, Value2 = 1, Value3 = 1, Value4 = 1;
            int result;
            if (retvalue == 0)
            {
                result = Libioctrl.getPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN1, ref Value1);
                if (result == 0)
                {
                    textBox1.Text = Value1.ToString();
                }

                result = Libioctrl.getPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN3, ref Value2);
                if (result == 0)
                {
                    textBox2.Text = Value2.ToString();
                }

                result = Libioctrl.getPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN5, ref Value3);
                if (result == 0)
                {
                    textBox3.Text = Value3.ToString();
                }

                result = Libioctrl.getPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN7, ref Value4);
                if (result == 0)
                {
                    textBox4.Text = Value4.ToString();
                }
            }
            else
            {
                MessageBox.Show("初始化失败,值是" + retvalue);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //int result;
            Libioctrl.__WDT_INFO wdtinfo;
            wdtinfo.enable = 0;
            wdtinfo.mode = (byte)Libioctrl.WDT_TIMER_MODE.WDT_SECOND_MODE;
            wdtinfo.nowayout = 1;
            wdtinfo.time = 80;

            if (retvalue == 0)
             {
#if OEM_TEST_WDT
                Libioctrl.OpenWatchdog(ref m_HModule, ref wdtinfo);

                //wdtinfo.enable = 1;
                //wdtinfo.mode = (byte)Libioctrl.WDT_TIMER_MODE.WDT_MINUTE_MODE;
                //wdtinfo.nowayout = 1;
                //wdtinfo.time = 80;
                //Libioctrl.updateWatchdog(ref m_HModule, ref wdtinfo); //configuration watchdog and enable wdt
                Libioctrl.enableWatchdog(ref m_HModule, 80); //启动WDT
                Libioctrl.KeepWatchdogAlive(ref m_HModule); //请在定时器或者线程函数中执行，在此仅为了表达调用顺序
                //Libioctrl.CloseWatchdog(ref m_HModule); //退出WDT
#else
                if (comboBox1.Text.Trim() == "1")
                 {
                     result = Libioctrl.setPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN2, Libioctrl.GPIO_LEVEL.GPIO_HIGH_LEVEL);
                     
                 }
                 else
                 {
                     result = Libioctrl.setPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN2, Libioctrl.GPIO_LEVEL.GPIO_LOW_LEVEL);
                 }

                 if (comboBox2.Text.Trim() == "1")
                 {
                     result = Libioctrl.setPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN4, Libioctrl.GPIO_LEVEL.GPIO_HIGH_LEVEL);

                 }
                 else
                 {
                     result = Libioctrl.setPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN4, Libioctrl.GPIO_LEVEL.GPIO_LOW_LEVEL);
                 }

                 if (comboBox3.Text.Trim() == "1")
                 {
                     result = Libioctrl.setPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN6, Libioctrl.GPIO_LEVEL.GPIO_HIGH_LEVEL);

                 }
                 else
                 {
                     result = Libioctrl.setPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN6, Libioctrl.GPIO_LEVEL.GPIO_LOW_LEVEL);
                 }

                 if (comboBox4.Text.Trim() == "1")
                 {
                     result = Libioctrl.setPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN8, Libioctrl.GPIO_LEVEL.GPIO_HIGH_LEVEL);

                 }
                 else
                 {
                     result = Libioctrl.setPinLevel(ref m_HModule, Libioctrl.GPIO_PIN_INDEX.GPIO_PIN8, Libioctrl.GPIO_LEVEL.GPIO_LOW_LEVEL);
                 }
#endif
            }
        }

        private void tableLayoutPanel1_Paint(object sender, PaintEventArgs e)
        {

        }
    }
}
