
// HzxWdtDemoDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "HzxWdtDemo.h"
#include "HzxWdtDemoDlg.h"
#include "afxdialogex.h"

#define TNID_WM_NOTIFYICON WM_USER+11

#define ID_WDT_TIMER      51
#define ID_GPIO_TIMER     52

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#if 0
#if ((defined OEM_ENABLE_WDT_SUPPORT) && (defined OEM_ENABLE_GPIO_SUPPORT))
#if (OEM_ENABLE_WDT_SUPPORT == 1) && (OEM_ENABLE_GPIO_SUPPORT == 1)
#error "ͬʱÿŹGPIOԣstdafx.hи"
#endif
#if (OEM_ENABLE_WDT_SUPPORT == 0) && (OEM_ENABLE_GPIO_SUPPORT == 0)
# error "ӦÿŹGPIOԣstdafx.hи"
#endif
#endif
#endif
/*
#ifdef _DEBUG
#pragma comment(lib,"libIoCtrlx64d.lib")
#else
#pragma comment(lib,"libIoCtrlx64.lib")
#endif
*/

#if _M_X64
#ifdef _DEBUG
#pragma comment(lib,"libIoCtrlx64d.lib")
#else
#pragma comment(lib,"libIoCtrlx64.lib")
#endif
#else
#ifdef _DEBUG
#pragma comment(lib,"libIoCtrlx86d.lib")
#else
#pragma comment(lib,"libIoCtrlx86.lib")
#endif
#endif

CString strProjectTitle =_T("HzxGPIOWdtDemo V2.0"); // L"HzxGPIOWdtDemo V2.0"

// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CHzxWdtDemoDlg Ի




CHzxWdtDemoDlg::CHzxWdtDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CHzxWdtDemoDlg::IDD, pParent)
	, m_nCounter(0),m_Mute(FALSE,NULL)
	, m_Pin1State(0)
	, m_Pin2State(0)
	, m_Pin3State(0)
	, m_Pin4State(0)
	, m_Pin5State(0)
	, m_Pin6State(0)
	, m_Pin7State(0)
	, m_Pin8State(0)
	, m_strBIOSID(_T(""))
	, m_Pin9State(0)
	, m_Pin10State(0)
	, m_Pin11State(0)
	, m_Pin12State(0)
	, m_Pin13State(0)
	, m_Pin14State(0)
	, m_Pin15State(0)
	, m_Pin16State(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_TimerID = 0;
	m_timerID_GP = 0;
	m_HModule = NULL;
	m_iGroupAState = 0;
	m_iGroupBState = 0;
	m_iPublicSwitchState = 0;
	m_nPBSAccState = 0;
	m_nPBSMode = 0;
	m_nPBSSupport = 0;
	m_nTotalGPIONum = 8;
	m_derection = 0x0000000;
	m_currentState = 0x0000000;
	m_fixedGpio = 0x00;
	m_beepCounter = 3;
}

void CHzxWdtDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_MODE, m_CtrlListMode);
	DDX_Control(pDX, IDC_CHECK_EXIT, m_CheckExit);
	DDX_Control(pDX, IDC_EDIT_COUNT, m_EditCount);
	DDX_Text(pDX, IDC_EDIT_COUNT, m_nCounter);
	DDV_MinMaxUInt(pDX, m_nCounter, 10, 255);
	DDX_Text(pDX, IDC_EDIT1, m_Pin1State);
	DDV_MinMaxByte(pDX, m_Pin1State, 0, 1);
	DDX_Text(pDX, IDC_EDIT2, m_Pin2State);
	DDV_MinMaxByte(pDX, m_Pin2State, 0, 1);
	DDX_Text(pDX, IDC_EDIT3, m_Pin3State);
	DDV_MinMaxByte(pDX, m_Pin3State, 0, 1);
	DDX_Text(pDX, IDC_EDIT4, m_Pin4State);
	DDV_MinMaxByte(pDX, m_Pin4State, 0, 1);
	DDX_Text(pDX, IDC_EDIT5, m_Pin5State);
	DDV_MinMaxByte(pDX, m_Pin5State, 0, 1);
	DDX_Text(pDX, IDC_EDIT6, m_Pin6State);
	DDV_MinMaxByte(pDX, m_Pin6State, 0, 1);
	DDX_Text(pDX, IDC_EDIT7, m_Pin7State);
	DDV_MinMaxByte(pDX, m_Pin7State, 0, 1);
	DDX_Text(pDX, IDC_EDIT8, m_Pin8State);
	DDV_MinMaxByte(pDX, m_Pin8State, 0, 1);
	DDX_Text(pDX, IDC_EDIT_BIOSID, m_strBIOSID);
	DDV_MaxChars(pDX, m_strBIOSID, 48);
	DDX_Text(pDX, IDC_EDIT10_BEEP_COUNT, m_beepCounter);
	DDV_MinMaxUInt(pDX, m_beepCounter, 1, 255);
	DDX_Text(pDX, IDC_EDIT9, m_Pin9State);
	DDV_MinMaxByte(pDX, m_Pin9State, 0, 1);
	DDX_Text(pDX, IDC_EDIT10, m_Pin10State);
	DDV_MinMaxByte(pDX, m_Pin10State, 0, 1);
	DDX_Text(pDX, IDC_EDIT11, m_Pin11State);
	DDV_MinMaxByte(pDX, m_Pin11State, 0, 1);
	DDX_Text(pDX, IDC_EDIT12, m_Pin12State);
	DDV_MinMaxByte(pDX, m_Pin12State, 0, 1);
	DDX_Text(pDX, IDC_EDIT13, m_Pin13State);
	DDV_MinMaxByte(pDX, m_Pin13State, 0, 1);
	DDX_Text(pDX, IDC_EDIT14, m_Pin14State);
	DDV_MinMaxByte(pDX, m_Pin14State, 0, 1);
	DDX_Text(pDX, IDC_EDIT15, m_Pin15State);
	DDV_MinMaxByte(pDX, m_Pin15State, 0, 1);
	DDX_Text(pDX, IDC_EDIT16, m_Pin16State);
	DDV_MinMaxByte(pDX, m_Pin16State, 0, 1);
}

BEGIN_MESSAGE_MAP(CHzxWdtDemoDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDCANCEL, &CHzxWdtDemoDlg::OnBnClickedCancel)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_EXIT, &CHzxWdtDemoDlg::OnBnClickedCheckExit)
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CHzxWdtDemoDlg::OnBnClickedButtonStop)
	ON_WM_CREATE()
	ON_COMMAND(ID_SHOW_SHOW, &CHzxWdtDemoDlg::OnShowShow)
	ON_CBN_SELCHANGE(IDC_COMBO1, &CHzxWdtDemoDlg::OnCbnSelchangeCombo1)
	ON_CBN_SELCHANGE(IDC_COMBO2, &CHzxWdtDemoDlg::OnCbnSelchangeCombo2)
	ON_CBN_SELCHANGE(IDC_COMBO3, &CHzxWdtDemoDlg::OnCbnSelchangeCombo3)
	ON_CBN_SELCHANGE(IDC_COMBO4, &CHzxWdtDemoDlg::OnCbnSelchangeCombo4)
	ON_CBN_SELCHANGE(IDC_COMBO5, &CHzxWdtDemoDlg::OnCbnSelchangeCombo5)
	ON_CBN_SELCHANGE(IDC_COMBO6, &CHzxWdtDemoDlg::OnCbnSelchangeCombo6)
	ON_CBN_SELCHANGE(IDC_COMBO7, &CHzxWdtDemoDlg::OnCbnSelchangeCombo7)
	ON_CBN_SELCHANGE(IDC_COMBO8, &CHzxWdtDemoDlg::OnCbnSelchangeCombo8)
	ON_BN_CLICKED(IDC_BUTTON3, &CHzxWdtDemoDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON2, &CHzxWdtDemoDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON_INIT, &CHzxWdtDemoDlg::OnBnClickedButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_PUBLIC, &CHzxWdtDemoDlg::OnBnClickedButtonPublic)
	ON_BN_CLICKED(IDC_BUTTON_GROUPA, &CHzxWdtDemoDlg::OnBnClickedButtonGroupa)
	ON_BN_CLICKED(IDC_BUTTON_GROUPB, &CHzxWdtDemoDlg::OnBnClickedButtonGroupb)
	ON_BN_CLICKED(IDC_BUTTON_PBS1, &CHzxWdtDemoDlg::OnBnClickedButtonPbs1)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE_BEEP, &CHzxWdtDemoDlg::OnBnClickedButtonEnableBeep)
	ON_CBN_SELCHANGE(IDC_COMBO9, &CHzxWdtDemoDlg::OnCbnSelchangeCombo9)
	ON_CBN_SELCHANGE(IDC_COMBO10, &CHzxWdtDemoDlg::OnCbnSelchangeCombo10)
	ON_CBN_SELCHANGE(IDC_COMBO11, &CHzxWdtDemoDlg::OnCbnSelchangeCombo11)
	ON_CBN_SELCHANGE(IDC_COMBO12, &CHzxWdtDemoDlg::OnCbnSelchangeCombo12)
	ON_CBN_SELCHANGE(IDC_COMBO13, &CHzxWdtDemoDlg::OnCbnSelchangeCombo13)
	ON_CBN_SELCHANGE(IDC_COMBO14, &CHzxWdtDemoDlg::OnCbnSelchangeCombo14)
	ON_CBN_SELCHANGE(IDC_COMBO15, &CHzxWdtDemoDlg::OnCbnSelchangeCombo15)
	ON_CBN_SELCHANGE(IDC_COMBO16, &CHzxWdtDemoDlg::OnCbnSelchangeCombo16)
END_MESSAGE_MAP()


// CHzxWdtDemoDlg Ϣ

BOOL CHzxWdtDemoDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ
	this->SetWindowTextW(strProjectTitle);

	m_CtrlListMode.SetCurSel(0);
	m_CheckExit.SetCheck(1);
	m_EditCount.SetWindowTextW(_T("20"));

	Update_Project_Setting(0);
	((CButton*)GetDlgItem(IDC_BUTTON_PUBLIC))->EnableWindow(0);
	((CButton*)GetDlgItem(IDC_BUTTON_GROUPA))->EnableWindow(0);
	((CButton*)GetDlgItem(IDC_BUTTON_GROUPB))->EnableWindow(0);

	((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->EnableWindow(0);
	((CButton*)GetDlgItem(IDC_BUTTON_PBS2))->EnableWindow(0);
	((CButton*)GetDlgItem(IDC_BUTTON_PBS3))->EnableWindow(0);

	Update_Beep_Setting(0);

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CHzxWdtDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CHzxWdtDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CHzxWdtDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CHzxWdtDemoDlg::OnBnClickedCancel()
{
	// TODO: ڴӿؼ֪ͨ
	if(AfxMessageBox(_T("Show Small Icon ?"),MB_OKCANCEL|MB_ICONQUESTION) == IDCANCEL){

		KillTimer(m_TimerID);
		KillTimer(m_timerID_GP);
		if(m_HModule != NULL)
			libIoCtrlDeinit(&m_HModule);

		::Shell_NotifyIcon(NIM_DELETE,&m_tnid); //رʱɾϵͳͼ
		CDialogEx::OnCancel();
	}
	else
		ShowWindow(SW_HIDE);
}


void CHzxWdtDemoDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ڴϢ/Ĭֵ

	if(nIDEvent == ID_WDT_TIMER){
		KeepWatchdogAlive(&m_HModule);
	}
	else if(nIDEvent == ID_GPIO_TIMER){
		Update_inputPin_State(&m_HModule);
	}


	CDialogEx::OnTimer(nIDEvent);
}


void CHzxWdtDemoDlg::OnBnClickedCheckExit()
{
	// TODO: ڴӿؼ֪ͨ
#if 0
	if(m_CheckExit.GetCheck()){
		((CButton*)GetDlgItem(IDC_BUTTON_STOP))->EnableWindow(0);
	}
	else{
		((CButton*)GetDlgItem(IDC_BUTTON_STOP))->EnableWindow(1);
	}
#endif
}


void CHzxWdtDemoDlg::OnBnClickedButtonStop()
{
	// TODO: ڴӿؼ֪ͨ
	static int btflag = 0;
	int wdtmode;
	unsigned char counter;
	unsigned char nowayout;
	unsigned char intervaltimer = 2;
	UpdateData(TRUE);
	wdtmode = m_CtrlListMode.GetCurSel();
	counter = m_nCounter;
	nowayout = m_CheckExit.GetCheck();
#if 1
	if(wdtmode == 0)
		wdtinfo.mode = WDT_SECOND_MODE;
	else
		wdtinfo.mode = WDT_MINUTE_MODE;
#endif
	//wdtinfo.mode = wdtmode;
	wdtinfo.nowayout = nowayout;
	wdtinfo.time = counter;
	
	if(btflag){
		btflag = !btflag;
		KillTimer(m_TimerID);
		m_TimerID = 0;
		GetDlgItem(IDC_BUTTON_STOP)->SetWindowTextW(_T("Enable WDT"));
		wdtinfo.enable = 0; //disable
		updateWatchdog(&m_HModule, &wdtinfo); //configuration watchdog and disable wdt
		//enableWatchdog(&m_HModule,0);
		((CButton*)GetDlgItem(IDC_CHECK_EXIT))->EnableWindow(1);
		((CComboBox*)GetDlgItem(IDC_COMBO_MODE))->EnableWindow(1);
		((CEdit*)GetDlgItem(IDC_EDIT_COUNT))->EnableWindow(1);
	}
	else{
		btflag = !btflag;
		GetDlgItem(IDC_BUTTON_STOP)->SetWindowTextW(_T("Disable WDT"));
		((CComboBox*)GetDlgItem(IDC_COMBO_MODE))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT_COUNT))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CHECK_EXIT))->EnableWindow(0);
		wdtinfo.enable = 1; //disable
		updateWatchdog(&m_HModule, &wdtinfo); //configuration watchdog and disable wdt
		//enableWatchdog(&m_HModule, 1);
		if (counter > 10) {
			intervaltimer = 5;
		}
		if(m_TimerID == 0)
			m_TimerID = SetTimer(ID_WDT_TIMER, (intervaltimer * 1000), NULL);
			//m_TimerID = SetTimer(ID_WDT_TIMER, (counter-3)*1000, NULL);
	}
}


int CHzxWdtDemoDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialogEx::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  ڴרõĴ
	//OnCreate return ֮ǰɴ  
	m_tnid.cbSize=sizeof(NOTIFYICONDATA);   
	m_tnid.hWnd=this->m_hWnd;   
	m_tnid.uFlags=NIF_MESSAGE|NIF_ICON|NIF_TIP;   
	m_tnid.uCallbackMessage=TNID_WM_NOTIFYICON;   
	//ûĻصϢ   
	CString szToolTip;   
	szToolTip=_T("Watchdog running"); //ƶʱʾı  
	lstrcpy(m_tnid.szTip, szToolTip);   
	m_tnid.uID=IDR_MAINFRAME;   
	HICON hIcon;   
	hIcon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);   
	m_tnid.hIcon=hIcon;   
	::Shell_NotifyIcon(NIM_ADD,&m_tnid);   
	if(hIcon)::DestroyIcon(hIcon);
	return 0;
}


LRESULT CHzxWdtDemoDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: ڴרô/û
	switch(message){ 
	case TNID_WM_NOTIFYICON:
		//ûϢ
		if(lParam==WM_LBUTTONDBLCLK)
		{
			//˫ʱڳ
			AfxGetApp()->m_pMainWnd->ShowWindow(SW_SHOW);
		}
		else if(lParam==WM_RBUTTONDOWN){ 
			//Ҽ˵
			CMenu menu;
			menu.LoadMenu(IDR_MENU1);
			//ȶĲ˵
			CMenu* pMenu=menu.GetSubMenu(0);
			CPoint pos;
			GetCursorPos(&pos);
			pMenu->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,pos.x,pos.y,this);
		}
		
			break;
	case WM_SYSCOMMAND:
		//ϵͳϢ   
        switch(wParam){  
          case SC_MINIMIZE:  
              //յСϢʱ   
              ShowWindow(SW_HIDE);   
              return 0;  
              break;  
          case SC_CLOSE :  
              ::Shell_NotifyIcon(NIM_DELETE,&m_tnid); //رʱɾϵͳͼ  
              break;  
        }
		break;
	}
		return CDialogEx::WindowProc(message, wParam, lParam);
}


void CHzxWdtDemoDlg::OnShowShow()
{
	// TODO: ڴ
	AfxGetApp()->m_pMainWnd->ShowWindow(SW_SHOW);
}


int CHzxWdtDemoDlg::Pin_inout_Sel(HMODULE* hModule, unsigned int derection, unsigned int currentState, unsigned char fixed, unsigned char gpioCount)
{
	BOOL visible = TRUE;
	if(*hModule == NULL)
		return -1;
	if (gpioCount < 4)
		return -1;

	if (fixed != GPIO_DYNAMIC_INOUT)
		visible = FALSE;

	if ((derection & (unsigned int)0x01) == DERECT_INPUT) {
		((CComboBox*)GetDlgItem(IDC_COMBO1))->SetCurSel(0);
		((CEdit*)GetDlgItem(IDC_EDIT1))->EnableWindow(0);
	}
	else {
		((CComboBox*)GetDlgItem(IDC_COMBO1))->SetCurSel(1);
		((CEdit*)GetDlgItem(IDC_EDIT1))->EnableWindow(1);
	}
	if (currentState & (unsigned int)0x01) {
		m_Pin1State = 1;
	}
	else {
		m_Pin1State = 0;
	}
	((CComboBox*)GetDlgItem(IDC_COMBO1))->EnableWindow(visible);

	if (((derection & (unsigned int)0x02) >> 1) == DERECT_INPUT) {
		((CComboBox*)GetDlgItem(IDC_COMBO2))->SetCurSel(0);
		((CEdit*)GetDlgItem(IDC_EDIT2))->EnableWindow(0);
	}
	else {
		((CComboBox*)GetDlgItem(IDC_COMBO2))->SetCurSel(1);
		((CEdit*)GetDlgItem(IDC_EDIT2))->EnableWindow(1);
	}
	if ((currentState & (unsigned int)0x02) >> 1) {
		m_Pin2State = 1;
	}
	else {
		m_Pin2State = 0;
		((CComboBox*)GetDlgItem(IDC_COMBO2))->EnableWindow(visible);
	}

	if (((derection & (unsigned int)0x04) >> 2) == DERECT_INPUT) {
		((CComboBox*)GetDlgItem(IDC_COMBO3))->SetCurSel(0);
		((CEdit*)GetDlgItem(IDC_EDIT3))->EnableWindow(0);
	}
	else {
		((CComboBox*)GetDlgItem(IDC_COMBO3))->SetCurSel(1);
		((CEdit*)GetDlgItem(IDC_EDIT3))->EnableWindow(1);
	}
	if ((currentState & (unsigned int)0x04) >> 2) {
		m_Pin3State = 1;
	}
	else {
		m_Pin3State = 0;
	}
	((CComboBox*)GetDlgItem(IDC_COMBO3))->EnableWindow(visible);

	if (((derection & (unsigned int)0x08) >> 3) == DERECT_INPUT) {
		((CComboBox*)GetDlgItem(IDC_COMBO4))->SetCurSel(0);
		((CEdit*)GetDlgItem(IDC_EDIT4))->EnableWindow(0);
	}
	else {
		((CComboBox*)GetDlgItem(IDC_COMBO4))->SetCurSel(1);
		((CEdit*)GetDlgItem(IDC_EDIT4))->EnableWindow(1);
	}

	if ((currentState & (unsigned int)0x08) >> 3) {
		m_Pin4State = 1;
	}
	else {
		m_Pin4State = 0;
	}
	((CComboBox*)GetDlgItem(IDC_COMBO4))->EnableWindow(visible);

	switch (gpioCount)
	{
	case 16:
		if (((derection & (unsigned int)0x8000) >> 15) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO16))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT16))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO16))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT16))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x8000) >> 15) {
			m_Pin16State = 1;
		}
		else {
			m_Pin16State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO16))->EnableWindow(visible);
	case 15:
		if (((derection & (unsigned int)0x4000) >> 14) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO15))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT15))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO15))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT15))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x4000) >> 14) {
			m_Pin15State = 1;
		}
		else {
			m_Pin15State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO15))->EnableWindow(visible);
	case 14:
		if (((derection & (unsigned int)0x2000) >> 13) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO14))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT14))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO14))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT14))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x2000) >> 13) {
			m_Pin14State = 1;
		}
		else {
			m_Pin14State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO14))->EnableWindow(visible);
	case 13:
		if (((derection & (unsigned int)0x1000) >> 12) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO13))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT13))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO13))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT13))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x1000) >> 12) {
			m_Pin13State = 1;
		}
		else {
			m_Pin13State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO13))->EnableWindow(visible);
	case 12:
		if (((derection & (unsigned int)0x800) >> 11) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO12))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT12))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO12))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT12))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x800) >> 11) {
			m_Pin12State = 1;
		}
		else {
			m_Pin12State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO12))->EnableWindow(visible);
	case 11:
		if (((derection & (unsigned int)0x400) >> 10) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO11))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT11))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO11))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT11))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x400) >> 10) {
			m_Pin11State = 1;
		}
		else {
			m_Pin11State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO11))->EnableWindow(visible);
	case 10:
		if (((derection & (unsigned int)0x200) >> 9) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO10))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT10))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO10))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT10))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x200) >> 9) {
			m_Pin10State = 1;
		}
		else {
			m_Pin10State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO10))->EnableWindow(visible);
	case 9:
		if (((derection & (unsigned int)0x100) >> 8) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO9))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT9))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO9))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT9))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x100) >> 8) {
			m_Pin9State = 1;
		}
		else {
			m_Pin9State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO9))->EnableWindow(visible);
	case 8:
		if (((derection & (unsigned int)0x80) >> 7) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO8))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT8))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO8))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT8))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x80) >> 7) {
			m_Pin8State = 1;
		}
		else {
			m_Pin8State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO8))->EnableWindow(visible);
	case 7:
		if (((derection & (unsigned int)0x40) >> 6) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO7))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT7))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO7))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT7))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x40) >> 6) {
			m_Pin7State = 1;
		}
		else {
			m_Pin7State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO7))->EnableWindow(visible);
	case 6:
		if (((derection & (unsigned int)0x20) >> 5) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO6))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT6))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO6))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT6))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x20) >> 5) {
			m_Pin6State = 1;
		}
		else {
			m_Pin6State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO6))->EnableWindow(visible);
	case 5:
		if (((derection & (unsigned int)0x10) >> 4) == DERECT_INPUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO5))->SetCurSel(0);
			((CEdit*)GetDlgItem(IDC_EDIT5))->EnableWindow(0);
		}
		else {
			((CComboBox*)GetDlgItem(IDC_COMBO5))->SetCurSel(1);
			((CEdit*)GetDlgItem(IDC_EDIT5))->EnableWindow(1);
		}
		if ((currentState & (unsigned int)0x10) >> 4) {
			m_Pin5State = 1;
		}
		else {
			m_Pin5State = 0;
		}
		((CComboBox*)GetDlgItem(IDC_COMBO5))->EnableWindow(visible);
		break;
	default:
		break;
	}

	UpdateData(FALSE);

	return 0;
}

//#define 
void CHzxWdtDemoDlg::OnCbnSelchangeCombo1()
{
	// TODO: ڴӿؼ֪ͨ
	int retvalue;
	if(0 == ((CComboBox*)GetDlgItem(IDC_COMBO1))->GetCurSel() ){
		((CEdit*)GetDlgItem(IDC_EDIT1))->EnableWindow(0);
		retvalue = setPinInOut(&m_HModule, GPIO_PIN1, DERECT_INPUT);
		retvalue = getPinLevel(&m_HModule, GPIO_PIN1, &m_Pin1State);
	}
	else{
		((CEdit*)GetDlgItem(IDC_EDIT1))->EnableWindow(1);
		retvalue = setPinInOut(&m_HModule, GPIO_PIN1, DERECT_OUPUT);
		retvalue = getPinLevel(&m_HModule, GPIO_PIN1, &m_Pin1State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo2()
{
	// TODO: ڴӿؼ֪ͨ
	if(0 == ((CComboBox*)GetDlgItem(IDC_COMBO2))->GetCurSel() ){
		((CEdit*)GetDlgItem(IDC_EDIT2))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN2, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN2, &m_Pin2State);
	}
	else{
		((CEdit*)GetDlgItem(IDC_EDIT2))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN2, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN2, &m_Pin2State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo3()
{
	// TODO: ڴӿؼ֪ͨ
	if(0 == ((CComboBox*)GetDlgItem(IDC_COMBO3))->GetCurSel() ){
		((CEdit*)GetDlgItem(IDC_EDIT3))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN3, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN3, &m_Pin3State);
	}
	else{
		((CEdit*)GetDlgItem(IDC_EDIT3))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN3, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN3, &m_Pin3State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo4()
{
	// TODO: ڴӿؼ֪ͨ
	if(0 == ((CComboBox*)GetDlgItem(IDC_COMBO4))->GetCurSel() ){
		((CEdit*)GetDlgItem(IDC_EDIT4))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN4, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN4, &m_Pin4State);
	}
	else{
		((CEdit*)GetDlgItem(IDC_EDIT4))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN4, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN4, &m_Pin4State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo5()
{
	// TODO: ڴӿؼ֪ͨ
	if(0 == ((CComboBox*)GetDlgItem(IDC_COMBO5))->GetCurSel() ){
		((CEdit*)GetDlgItem(IDC_EDIT5))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN5, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN5, &m_Pin5State);
	}
	else{
		((CEdit*)GetDlgItem(IDC_EDIT5))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN5, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN5, &m_Pin5State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo6()
{
	// TODO: ڴӿؼ֪ͨ
	if(0 == ((CComboBox*)GetDlgItem(IDC_COMBO6))->GetCurSel() ){
		((CEdit*)GetDlgItem(IDC_EDIT6))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN6, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN6, &m_Pin6State);
	}
	else{
		((CEdit*)GetDlgItem(IDC_EDIT6))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN6, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN6, &m_Pin6State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo7()
{
	// TODO: ڴӿؼ֪ͨ
	if(0 == ((CComboBox*)GetDlgItem(IDC_COMBO7))->GetCurSel() ){
		((CEdit*)GetDlgItem(IDC_EDIT7))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN7, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN7, &m_Pin7State);
	}
	else{
		((CEdit*)GetDlgItem(IDC_EDIT7))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN7, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN7, &m_Pin7State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo8()
{
	// TODO: ڴӿؼ֪ͨ
	if(0 == ((CComboBox*)GetDlgItem(IDC_COMBO8))->GetCurSel() ){
		((CEdit*)GetDlgItem(IDC_EDIT8))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN8, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN8, &m_Pin8State);
	}
	else{
		((CEdit*)GetDlgItem(IDC_EDIT8))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN8, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN8, &m_Pin8State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnBnClickedButton2()
{
	// TODO: ڴӿؼ֪ͨ
	static BOOL flag = FALSE;
	if(flag){
		KillTimer(m_timerID_GP);
		m_timerID_GP = 0;
		GetDlgItem(IDC_BUTTON2)->SetWindowTextW(_T("Poll input"));
		Update_InOut_Setting(&m_HModule,TRUE);
		((CButton*)GetDlgItem(IDC_BUTTON3))->EnableWindow(1);
		flag = !flag;
	}
	else{
		if(m_timerID_GP == 0)
			m_timerID_GP = SetTimer(ID_GPIO_TIMER,100,NULL); //100ms
		GetDlgItem(IDC_BUTTON2)->SetWindowTextW(_T("Stop Poll"));
		Update_InOut_Setting(&m_HModule,FALSE);
		((CButton*)GetDlgItem(IDC_BUTTON3))->EnableWindow(0);
		flag = !flag;
	}

}


void CHzxWdtDemoDlg::OnBnClickedButton3()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData(TRUE);
	if (((CComboBox*)GetDlgItem(IDC_COMBO1))->GetCurSel() == 1) {
		if (m_Pin1State)
			setPinLevel(&m_HModule, GPIO_PIN1, GPIO_HIGH_LEVEL);
		else
			setPinLevel(&m_HModule, GPIO_PIN1, GPIO_LOW_LEVEL);
	}

	if(((CComboBox*)GetDlgItem(IDC_COMBO2))->GetCurSel() == 1){
		if(m_Pin2State)
			setPinLevel(&m_HModule, GPIO_PIN2, GPIO_HIGH_LEVEL);
		else
			setPinLevel(&m_HModule, GPIO_PIN2, GPIO_LOW_LEVEL);
	}

	if(((CComboBox*)GetDlgItem(IDC_COMBO3))->GetCurSel() == 1){
		if(m_Pin3State)
			setPinLevel(&m_HModule, GPIO_PIN3, GPIO_HIGH_LEVEL);
		else
			setPinLevel(&m_HModule, GPIO_PIN3, GPIO_LOW_LEVEL);
	}

	if (((CComboBox*)GetDlgItem(IDC_COMBO4))->GetCurSel() == 1) {
		if (m_Pin4State)
			setPinLevel(&m_HModule, GPIO_PIN4, GPIO_HIGH_LEVEL);
		else
			setPinLevel(&m_HModule, GPIO_PIN4, GPIO_LOW_LEVEL);
	}

	switch (m_nTotalGPIONum)
	{
	case 16:
		if (((CComboBox*)GetDlgItem(IDC_COMBO16))->GetCurSel() == 1) {
			if (m_Pin16State)
				setPinLevel(&m_HModule, GPIO_PIN16, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN16, GPIO_LOW_LEVEL);
		}
	case 15:
		if (((CComboBox*)GetDlgItem(IDC_COMBO15))->GetCurSel() == 1) {
			if (m_Pin15State)
				setPinLevel(&m_HModule, GPIO_PIN15, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN15, GPIO_LOW_LEVEL);
		}
	case 14:
		if (((CComboBox*)GetDlgItem(IDC_COMBO14))->GetCurSel() == 1) {
			if (m_Pin14State)
				setPinLevel(&m_HModule, GPIO_PIN14, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN14, GPIO_LOW_LEVEL);
		}
	case 13:
		if (((CComboBox*)GetDlgItem(IDC_COMBO13))->GetCurSel() == 1) {
			if (m_Pin13State)
				setPinLevel(&m_HModule, GPIO_PIN13, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN13, GPIO_LOW_LEVEL);
		}
	case 12:
		if (((CComboBox*)GetDlgItem(IDC_COMBO12))->GetCurSel() == 1) {
			if (m_Pin12State)
				setPinLevel(&m_HModule, GPIO_PIN12, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN12, GPIO_LOW_LEVEL);
		}
	case 11:
		if (((CComboBox*)GetDlgItem(IDC_COMBO11))->GetCurSel() == 1) {
			if (m_Pin11State)
				setPinLevel(&m_HModule, GPIO_PIN11, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN11, GPIO_LOW_LEVEL);
		}
	case 10:
		if (((CComboBox*)GetDlgItem(IDC_COMBO10))->GetCurSel() == 1) {
			if (m_Pin10State)
				setPinLevel(&m_HModule, GPIO_PIN10, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN10, GPIO_LOW_LEVEL);
		}
	case 9:
		if (((CComboBox*)GetDlgItem(IDC_COMBO9))->GetCurSel() == 1) {
			if (m_Pin9State)
				setPinLevel(&m_HModule, GPIO_PIN9, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN9, GPIO_LOW_LEVEL);
		}
	case 8:
		if (((CComboBox*)GetDlgItem(IDC_COMBO8))->GetCurSel() == 1) {
			if (m_Pin8State)
				setPinLevel(&m_HModule, GPIO_PIN8, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN8, GPIO_LOW_LEVEL);
		}
	case 7:
		if (((CComboBox*)GetDlgItem(IDC_COMBO7))->GetCurSel() == 1) {
			if (m_Pin7State)
				setPinLevel(&m_HModule, GPIO_PIN7, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN7, GPIO_LOW_LEVEL);
		}
	case 6:
		if (((CComboBox*)GetDlgItem(IDC_COMBO6))->GetCurSel() == 1) {
			if (m_Pin6State)
				setPinLevel(&m_HModule, GPIO_PIN6, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN6, GPIO_LOW_LEVEL);
		}
	case 5:
		if (((CComboBox*)GetDlgItem(IDC_COMBO5))->GetCurSel() == 1) {
			if (m_Pin5State)
				setPinLevel(&m_HModule, GPIO_PIN5, GPIO_HIGH_LEVEL);
			else
				setPinLevel(&m_HModule, GPIO_PIN5, GPIO_LOW_LEVEL);
		}
		break;
	default:
		break;
	}

}

int CHzxWdtDemoDlg::Update_inputPin_State(HMODULE* hModule)
{
	BYTE Value1,Value2,Value3,Value4,Value5,Value6,Value7,Value8;
	BYTE Value9, Value10, Value11, Value12, Value13, Value14, Value15, Value16;
	if(*hModule == NULL)
		return -1;
	UpdateData(TRUE);
	if(((CComboBox*)GetDlgItem(IDC_COMBO1))->GetCurSel() == 0){
			getPinLevel(hModule, GPIO_PIN1, &Value1);
			m_Pin1State = Value1;
	}

	if(((CComboBox*)GetDlgItem(IDC_COMBO2))->GetCurSel() == 0){
			getPinLevel(hModule, GPIO_PIN2, &Value2);
			m_Pin2State = Value2;
	}

	if(((CComboBox*)GetDlgItem(IDC_COMBO3))->GetCurSel() == 0){
			getPinLevel(hModule, GPIO_PIN3, &Value3);
			m_Pin3State = Value3;
	}

	if(((CComboBox*)GetDlgItem(IDC_COMBO4))->GetCurSel() == 0){
			getPinLevel(hModule, GPIO_PIN4, &Value4);
			m_Pin4State = Value4;
	}

	switch (m_nTotalGPIONum)
	{
	case 16:
		if (((CComboBox*)GetDlgItem(IDC_COMBO16))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN16, &Value16);
			m_Pin16State = Value16;
		}
	case 15:
		if (((CComboBox*)GetDlgItem(IDC_COMBO15))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN15, &Value15);
			m_Pin15State = Value15;
		}
	case 14:
		if (((CComboBox*)GetDlgItem(IDC_COMBO14))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN14, &Value14);
			m_Pin14State = Value14;
		}
	case 13:
		if (((CComboBox*)GetDlgItem(IDC_COMBO13))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN13, &Value13);
			m_Pin13State = Value13;
		}
	case 12:
		if (((CComboBox*)GetDlgItem(IDC_COMBO12))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN12, &Value12);
			m_Pin12State = Value12;
		}
	case 11:
		if (((CComboBox*)GetDlgItem(IDC_COMBO11))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN16, &Value11);
			m_Pin11State = Value11;
		}
	case 10:
		if (((CComboBox*)GetDlgItem(IDC_COMBO10))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN16, &Value10);
			m_Pin10State = Value10;
		}
	case 9:
		if (((CComboBox*)GetDlgItem(IDC_COMBO9))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN9, &Value9);
			m_Pin9State = Value9;
		}
	case 8:
		if (((CComboBox*)GetDlgItem(IDC_COMBO8))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN8, &Value8);
			m_Pin8State = Value8;
		}
	case 7:
		if (((CComboBox*)GetDlgItem(IDC_COMBO7))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN7, &Value7);
			m_Pin7State = Value7;
		}
	case 6:
		if (((CComboBox*)GetDlgItem(IDC_COMBO6))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN6, &Value6);
			m_Pin6State = Value6;
		}
	case 5:
		if (((CComboBox*)GetDlgItem(IDC_COMBO5))->GetCurSel() == 0) {
			getPinLevel(hModule, GPIO_PIN5, &Value5);
			m_Pin5State = Value5;
		}
		break;
	default:
		break;
	}

	UpdateData(FALSE);
	return 0;
}

int CHzxWdtDemoDlg::Update_InOut_Setting(HMODULE* hModule,BOOL bEnable)
{
	
	if (bEnable) {
		if (m_fixedGpio == GPIO_DYNAMIC_INOUT) {
			((CComboBox*)GetDlgItem(IDC_COMBO1))->EnableWindow(1);
			((CComboBox*)GetDlgItem(IDC_COMBO2))->EnableWindow(1);
			((CComboBox*)GetDlgItem(IDC_COMBO3))->EnableWindow(1);
			((CComboBox*)GetDlgItem(IDC_COMBO4))->EnableWindow(1);
			switch (m_nTotalGPIONum)
			{
			case 16:
				((CComboBox*)GetDlgItem(IDC_COMBO16))->EnableWindow(1);
			case 15:
				((CComboBox*)GetDlgItem(IDC_COMBO15))->EnableWindow(1);
			case 14:
				((CComboBox*)GetDlgItem(IDC_COMBO14))->EnableWindow(1);
			case 13:
				((CComboBox*)GetDlgItem(IDC_COMBO13))->EnableWindow(1);
			case 12:
				((CComboBox*)GetDlgItem(IDC_COMBO12))->EnableWindow(1);
			case 11:
				((CComboBox*)GetDlgItem(IDC_COMBO11))->EnableWindow(1);
			case 10:
				((CComboBox*)GetDlgItem(IDC_COMBO10))->EnableWindow(1);
			case 9:
				((CComboBox*)GetDlgItem(IDC_COMBO9))->EnableWindow(1);
			case 8:
				((CComboBox*)GetDlgItem(IDC_COMBO8))->EnableWindow(1);
			case 7:
				((CComboBox*)GetDlgItem(IDC_COMBO7))->EnableWindow(1);
			case 6:
				((CComboBox*)GetDlgItem(IDC_COMBO6))->EnableWindow(1);
			case 5:
				((CComboBox*)GetDlgItem(IDC_COMBO5))->EnableWindow(1);
				break;
			default:
				break;
			}
		}

	}
	else {
		((CComboBox*)GetDlgItem(IDC_COMBO1))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO2))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO3))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO4))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO5))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO6))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO7))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO8))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO9))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO10))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO11))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO12))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO13))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO14))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO15))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO16))->EnableWindow(0);
	}
	return 0;
}


/*
BOOL CHzxWdtDemoDlg::Isx64System()
{
    typedef BOOL (WINAPI *LPFN_ISWOW64PROCESS) (HANDLE, PBOOL);
    LPFN_ISWOW64PROCESS fnIsWow64Process;
    BOOL bIsWow64 = FALSE;
    fnIsWow64Process = (LPFN_ISWOW64PROCESS)GetProcAddress( GetModuleHandle("kernel32"),"IsWow64Process");
    if (NULL != fnIsWow64Process)
    {
        fnIsWow64Process(GetCurrentProcess(),&bIsWow64);
    }
    return bIsWow64;
}
*/
int CHzxWdtDemoDlg::Update_Project_Setting(BOOL bEnable)
{
	if (bEnable) {
		((CComboBox*)GetDlgItem(IDC_COMBO_MODE))->EnableWindow(1);
		((CEdit*)GetDlgItem(IDC_EDIT_COUNT))->EnableWindow(1);
		((CButton*)GetDlgItem(IDC_CHECK_EXIT))->EnableWindow(1);
		((CButton*)GetDlgItem(IDC_BUTTON_STOP))->EnableWindow(1);
		((CButton*)GetDlgItem(IDC_BUTTON2))->EnableWindow(1);
		((CButton*)GetDlgItem(IDC_BUTTON3))->EnableWindow(1);
		//((CEdit*)GetDlgItem(IDC_EDIT1))->EnableWindow(1);
		//((CEdit*)GetDlgItem(IDC_EDIT2))->EnableWindow(1);
		//((CEdit*)GetDlgItem(IDC_EDIT3))->EnableWindow(1);
		//((CEdit*)GetDlgItem(IDC_EDIT4))->EnableWindow(1);
		//((CEdit*)GetDlgItem(IDC_EDIT5))->EnableWindow(1);
		//((CEdit*)GetDlgItem(IDC_EDIT6))->EnableWindow(1);
		//((CEdit*)GetDlgItem(IDC_EDIT7))->EnableWindow(1);
		//((CEdit*)GetDlgItem(IDC_EDIT8))->EnableWindow(1);
		//((CComboBox*)GetDlgItem(IDC_COMBO1))->EnableWindow(1);
		//((CComboBox*)GetDlgItem(IDC_COMBO2))->EnableWindow(1);
		//((CComboBox*)GetDlgItem(IDC_COMBO3))->EnableWindow(1);
		//((CComboBox*)GetDlgItem(IDC_COMBO4))->EnableWindow(1);
		//((CComboBox*)GetDlgItem(IDC_COMBO5))->EnableWindow(1);
		//((CComboBox*)GetDlgItem(IDC_COMBO6))->EnableWindow(1);
		//((CComboBox*)GetDlgItem(IDC_COMBO7))->EnableWindow(1);
		//((CComboBox*)GetDlgItem(IDC_COMBO8))->EnableWindow(1);
	}
	else {
		((CComboBox*)GetDlgItem(IDC_COMBO_MODE))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT_COUNT))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_CHECK_EXIT))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_BUTTON_STOP))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_BUTTON2))->EnableWindow(0);
		((CButton*)GetDlgItem(IDC_BUTTON3))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT1))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT2))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT3))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT4))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT5))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT6))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT7))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT8))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT9))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT10))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT11))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT12))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT13))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT14))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT15))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT16))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO1))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO2))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO3))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO4))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO5))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO6))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO7))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO8))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO9))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO10))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO11))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO12))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO13))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO14))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO15))->EnableWindow(0);
		((CComboBox*)GetDlgItem(IDC_COMBO16))->EnableWindow(0);
	}
	return 0;
}



void CHzxWdtDemoDlg::OnBnClickedButtonInit()
{
	// TODO: ڴӿؼ֪ͨ
	//CString TempStr;
	int strinlen;
	int retvalue;
	char bios_id[255]={'\0'};
	char version[128] = {'\0'};
	CString messageStr;
	//unsigned int derection; unsigned int currentState; unsigned char fixed;
	UpdateData(TRUE);


	DWORD dwMinSize;
	m_strBIOSID.TrimLeft();
	m_strBIOSID.TrimRight();
	strinlen = m_strBIOSID.GetLength();

	dwMinSize = WideCharToMultiByte(CP_ACP, NULL, m_strBIOSID, strinlen, NULL, 0, NULL, NULL);
	WideCharToMultiByte(CP_ACP, NULL, m_strBIOSID, strinlen, bios_id, dwMinSize, NULL, NULL);
	//m_strBIOSID.ReleaseBuffer();
	bios_id[dwMinSize + 1] = '\0';

	retvalue = libIoCtrlInit(&m_HModule, bios_id);
	//	retvalue = libIoCtrlInit(&m_HModule,bios_id);
	if (retvalue != 0) {
		//messageStr = _T("Init lib failed: ");
		messageStr.Format(_T("Init lib failed: %d"), retvalue);
		AfxMessageBox(messageStr, MB_OK| MB_ICONSTOP);
		return;
	}

	libIoCtrlGetVersion(&m_HModule, version);

	Update_Beep_Setting(1);

	getGpioState(&m_HModule, &m_derection, &m_currentState, &m_fixedGpio);

	getGpioMaxPin(&m_HModule, &m_nTotalGPIONum);

	//	if(0 == retvalue){
	Pin_inout_Sel(&m_HModule, m_derection, m_currentState, m_fixedGpio, m_nTotalGPIONum);
	wdtinfo.enable = 0;
	wdtinfo.mode = WDT_SECOND_MODE;
	wdtinfo.nowayout = 0;
	wdtinfo.time = 20;
	OpenWatchdog(&m_HModule, &wdtinfo);

	Lan_Bypass_Init(&m_HModule);

	PBS_Init(&m_HModule);

	Update_Project_Setting(1);

	//	}
	return;
}
int  CHzxWdtDemoDlg::Update_Beep_Setting(BOOL bEnalbe)
{
	if (bEnalbe) {
		((CButton*)GetDlgItem(IDC_BUTTON_ENABLE_BEEP))->EnableWindow(1);
		((CEdit*)GetDlgItem(IDC_EDIT10_BEEP_COUNT))->EnableWindow(1);
	}
	else {
		((CButton*)GetDlgItem(IDC_BUTTON_ENABLE_BEEP))->EnableWindow(0);
		((CEdit*)GetDlgItem(IDC_EDIT10_BEEP_COUNT))->EnableWindow(0);
	}
	return 1;
}

int CHzxWdtDemoDlg::Lan_Bypass_Init(HMODULE* hModule)
{
	unsigned char IsSupport = 0;
	unsigned char state = 0;
	//m_iGroupAState = 0;
	//m_iGroupBState = 0;
	((CButton*)GetDlgItem(IDC_BUTTON_PUBLIC))->EnableWindow(0);
	((CButton*)GetDlgItem(IDC_BUTTON_GROUPA))->EnableWindow(0);
	((CButton*)GetDlgItem(IDC_BUTTON_GROUPB))->EnableWindow(0);
	IsLanBypassSupported(hModule, &IsSupport);
	if (IsSupport)
	{
		GetLanBypassState(hModule, &state);
		if (state & LBP_GROUPA_MASK)
			m_iGroupAState = 1;
		if (state & LBP_GROUPB_MASK)
			m_iGroupBState = 1;

		if (m_iGroupAState) {
			((CButton*)GetDlgItem(IDC_BUTTON_GROUPA))->SetWindowTextW(_T("Disable"));
		}
		else
		{
			((CButton*)GetDlgItem(IDC_BUTTON_GROUPA))->SetWindowTextW(_T("Enable"));
		}
		if (m_iGroupBState) {
			((CButton*)GetDlgItem(IDC_BUTTON_GROUPB))->SetWindowTextW(_T("Disable"));
		}
		else
		{
			((CButton*)GetDlgItem(IDC_BUTTON_GROUPB))->SetWindowTextW(_T("Enable"));
		}
		((CButton*)GetDlgItem(IDC_BUTTON_GROUPA))->EnableWindow(1);
		((CButton*)GetDlgItem(IDC_BUTTON_GROUPB))->EnableWindow(1);
	}
	return 0;
}

void CHzxWdtDemoDlg::OnBnClickedButtonPublic()
{
	// TODO: ڴӿؼ֪ͨ
}


void CHzxWdtDemoDlg::OnBnClickedButtonGroupa()
{
	// TODO: ڴӿؼ֪ͨ
	if (m_iGroupAState) {
		LanBypassEnable(&m_HModule, BYPASS_GROUPA_INDEX, 0);
		m_iGroupAState = !m_iGroupAState;
		((CButton*)GetDlgItem(IDC_BUTTON_GROUPA))->SetWindowTextW(_T("Enable"));
	}
	else {
		LanBypassEnable(&m_HModule, BYPASS_GROUPA_INDEX, 1);
		m_iGroupAState = !m_iGroupAState;
		((CButton*)GetDlgItem(IDC_BUTTON_GROUPA))->SetWindowTextW(_T("Disable"));
	}

}


void CHzxWdtDemoDlg::OnBnClickedButtonGroupb()
{
	// TODO: ڴӿؼ֪ͨ
	if (m_iGroupBState) {
		LanBypassEnable(&m_HModule, BYPASS_GROUPB_INDEX, 0);
		m_iGroupBState = !m_iGroupBState;
		((CButton*)GetDlgItem(IDC_BUTTON_GROUPB))->SetWindowTextW(_T("Enable"));
	}
	else {
		LanBypassEnable(&m_HModule, BYPASS_GROUPB_INDEX, 1);
		m_iGroupBState = !m_iGroupBState;
		((CButton*)GetDlgItem(IDC_BUTTON_GROUPB))->SetWindowTextW(_T("Disable"));
	}
}
int CHzxWdtDemoDlg::PBS_Init(HMODULE* hModule)
{
	//m_nPBSAccState = 0;
	//m_nPBSMode = 0;
	((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->EnableWindow(0);
	((CButton*)GetDlgItem(IDC_BUTTON_PBS2))->EnableWindow(0);
	((CButton*)GetDlgItem(IDC_BUTTON_PBS3))->EnableWindow(0);
	IsPowerButtonSWSupported(hModule, &m_nPBSSupport);
	if (m_nPBSSupport)
	{
		GetPowerButtonSWAccessState(hModule, &m_nPBSAccState,&m_nPBSMode);
		if (m_nPBSAccState & PBS_SW1_MASK)
		{
			if (m_nPBSMode & PBS_SW1_MASK) {
				((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->SetWindowTextW(_T("Trigger"));
			}
			else
			{
				((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->SetWindowTextW(_T("Enable"));
			}

			((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->EnableWindow(1);
		}

		if (m_nPBSAccState & PBS_SW2_MASK)
		{
			if (m_nPBSMode & PBS_SW2_MASK) {
				((CButton*)GetDlgItem(IDC_BUTTON_PBS2))->SetWindowTextW(_T("Trigger"));
			}
			else
			{
				((CButton*)GetDlgItem(IDC_BUTTON_PBS2))->SetWindowTextW(_T("Enable"));
			}

			((CButton*)GetDlgItem(IDC_BUTTON_PBS2))->EnableWindow(1);
		}

		if (m_nPBSAccState & PBS_SW3_MASK)
		{
			if (m_nPBSMode & PBS_SW3_MASK) {
				((CButton*)GetDlgItem(IDC_BUTTON_PBS3))->SetWindowTextW(_T("Trigger"));
			}
			else
			{
				((CButton*)GetDlgItem(IDC_BUTTON_PBS3))->SetWindowTextW(_T("Enable"));
			}

			((CButton*)GetDlgItem(IDC_BUTTON_PBS3))->EnableWindow(1);
		}
	}
	return 0;
}


void CHzxWdtDemoDlg::OnBnClickedButtonPbs1()
{
	// TODO: ڴӿؼ֪ͨ
	static unsigned char clickFlag = 0;
	if (m_nPBSAccState & PBS_SW1_MASK)
	{
		if (!(m_nPBSMode & PBS_SW1_MASK)) {
			((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->EnableWindow(0);
			if (clickFlag)
			{
				clickFlag = !clickFlag;
				PowerButtonSWEnable(&m_HModule, POWER_BUTTON1, 0);
				((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->SetWindowTextW(_T("Enable"));
			}
			else
			{
				clickFlag = !clickFlag;
				PowerButtonSWEnable(&m_HModule, POWER_BUTTON1, 1);
				((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->SetWindowTextW(_T("Disable"));
			}
			((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->EnableWindow(1);
		}
		else
		{
			((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->EnableWindow(0);
			PowerButtonSWEnable(&m_HModule, POWER_BUTTON1, 1);
			((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->EnableWindow(1);
		}

		//((CButton*)GetDlgItem(IDC_BUTTON_PBS1))->EnableWindow(1);
	}
}


void CHzxWdtDemoDlg::OnBnClickedButtonEnableBeep()
{
	// TODO: ڴӿؼ֪ͨ
	BYTE LoopCount = 0;
	UpdateData(TRUE);

	((CButton*)GetDlgItem(IDC_BUTTON_ENABLE_BEEP))->EnableWindow(0);
	((CEdit*)GetDlgItem(IDC_EDIT10_BEEP_COUNT))->EnableWindow(0);

	for (LoopCount = 0; LoopCount < m_beepCounter; LoopCount++)
	{
		SysBeepEnable(&m_HModule, 0);
		Sleep(1000);
	}

	((CButton*)GetDlgItem(IDC_BUTTON_ENABLE_BEEP))->EnableWindow(1);
	((CEdit*)GetDlgItem(IDC_EDIT10_BEEP_COUNT))->EnableWindow(1);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo9()
{
	// TODO: ڴӿؼ֪ͨ
	if (0 == ((CComboBox*)GetDlgItem(IDC_COMBO9))->GetCurSel()) {
		((CEdit*)GetDlgItem(IDC_EDIT9))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN9, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN9, &m_Pin9State);
	}
	else {
		((CEdit*)GetDlgItem(IDC_EDIT9))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN9, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN9, &m_Pin8State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo10()
{
	// TODO: ڴӿؼ֪ͨ
	if (0 == ((CComboBox*)GetDlgItem(IDC_COMBO10))->GetCurSel()) {
		((CEdit*)GetDlgItem(IDC_EDIT10))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN10, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN10, &m_Pin8State);
	}
	else {
		((CEdit*)GetDlgItem(IDC_EDIT10))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN10, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN10, &m_Pin8State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo11()
{
	// TODO: ڴӿؼ֪ͨ
	if (0 == ((CComboBox*)GetDlgItem(IDC_COMBO11))->GetCurSel()) {
		((CEdit*)GetDlgItem(IDC_EDIT11))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN11, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN11, &m_Pin8State);
	}
	else {
		((CEdit*)GetDlgItem(IDC_EDIT11))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN11, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN11, &m_Pin8State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo12()
{
	// TODO: ڴӿؼ֪ͨ
	if (0 == ((CComboBox*)GetDlgItem(IDC_COMBO12))->GetCurSel()) {
		((CEdit*)GetDlgItem(IDC_EDIT12))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN12, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN12, &m_Pin8State);
	}
	else {
		((CEdit*)GetDlgItem(IDC_EDIT12))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN12, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN12, &m_Pin8State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo13()
{
	// TODO: ڴӿؼ֪ͨ
	if (0 == ((CComboBox*)GetDlgItem(IDC_COMBO13))->GetCurSel()) {
		((CEdit*)GetDlgItem(IDC_EDIT13))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN13, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN13, &m_Pin8State);
	}
	else {
		((CEdit*)GetDlgItem(IDC_EDIT13))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN13, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN13, &m_Pin8State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo14()
{
	// TODO: ڴӿؼ֪ͨ
	if (0 == ((CComboBox*)GetDlgItem(IDC_COMBO14))->GetCurSel()) {
		((CEdit*)GetDlgItem(IDC_EDIT14))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN14, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN14, &m_Pin8State);
	}
	else {
		((CEdit*)GetDlgItem(IDC_EDIT14))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN14, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN14, &m_Pin8State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo15()
{
	// TODO: ڴӿؼ֪ͨ
	if (0 == ((CComboBox*)GetDlgItem(IDC_COMBO15))->GetCurSel()) {
		((CEdit*)GetDlgItem(IDC_EDIT15))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN15, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN15, &m_Pin8State);
	}
	else {
		((CEdit*)GetDlgItem(IDC_EDIT15))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN15, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN15, &m_Pin8State);
	}
	UpdateData(FALSE);
}


void CHzxWdtDemoDlg::OnCbnSelchangeCombo16()
{
	// TODO: ڴӿؼ֪ͨ
	if (0 == ((CComboBox*)GetDlgItem(IDC_COMBO16))->GetCurSel()) {
		((CEdit*)GetDlgItem(IDC_EDIT16))->EnableWindow(0);
		setPinInOut(&m_HModule, GPIO_PIN16, DERECT_INPUT);
		getPinLevel(&m_HModule, GPIO_PIN16, &m_Pin8State);
	}
	else {
		((CEdit*)GetDlgItem(IDC_EDIT16))->EnableWindow(1);
		setPinInOut(&m_HModule, GPIO_PIN16, DERECT_OUPUT);
		getPinLevel(&m_HModule, GPIO_PIN16, &m_Pin8State);
	}
	UpdateData(FALSE);
}
